

## Giới thiệu

Package localization cung cấp việc sử dụng đa ngôn ngữ và việc thay đổi ngôn ngữ cho ứng dụng.
Localization được được base trên flutter version 2.10.1 , dart 2.16.1 hỗ trợ null safety

## Version note

version 1

## Cách import package vào 1 dự án

B1: tạo 1 thư mục chứa các package được cắm từ bên ngoài vào ngang cấp với các thư mục assets hoặc android và ios.
B2: import package vào thư mục vừa được tạo ở bước 1
B3: khai báo packagae như 1 thư viện vào pubspect.yaml của project

#### Ví Dụ:
        localizations:
            path: ./tên thư mục được tạo ở bước 1/localizations



## Khởi tạo và sử dụng trong project

 Khi import package thành công vào bên trong project ta sẽ thực hiện khởi tạo và sử dụng trong project bằng các bước.

### B1: Khởi tạo tại hàm main.dart trong widget MaterialApp()

#### Ví dụ:
```dart
     @override
Widget build(BuildContext context) {
  return MultiProvider(
    child: MaterialApp(
      localizationsDelegates: [
        GlobalMaterialLocalizations.delegate,
        GlobalWidgetsLocalizations.delegate,
        GlobalCupertinoLocalizations.delegate,
        AppLocalizations.delegate,
      ],
      localeResolutionCallback: (locale, supportedLocales) {
        for (var supportedLocale in supportedLocales) {
          if (supportedLocale.languageCode == locale!.languageCode &&
              supportedLocale.countryCode == locale.countryCode) {
            return supportedLocale;
          }
        }
        return supportedLocales.first;
      },
      supportedLocales: const [
        Locale('vi', 'VN'),
        Locale('en', 'US'),
      ],
    ),
  );
}
```
### B2: gọi và sử dụng các biến

#### bất cứ đâu cần sử dụng các biến trong localizations ta chỉ cần sử dụng câu lệnh sau đây với đầu vào là 1 key,
```dart
    AppLocalizations.of(context)!.translate('key');
```
### Để thêm 1 biến vào locaization chúng ta khai báo biến theo dạng key_value bên trong các file .../localizations/assets/lang
### lưu ý 1 biến được tạo cho nhiều ngôn ngữ bên trong localization đều phải đặt tên key giống nhau chỉ có thể khác các giá trị.

